Index: sasmodels/models/fuzzy_sphere.c
===================================================================
--- sasmodels/models/fuzzy_sphere.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
+++ sasmodels/models/fuzzy_sphere.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -0,0 +1,27 @@
+static double form_volume(double radius, double fuzziness)
+{
+    return M_4PI_3*cube(radius);
+}
+
+static double
+effective_radius(int mode, double radius, double fuzziness)
+{
+    switch (mode) {
+    case 1: // radius
+        return radius;
+    case 2: // radius + fuzziness
+        return radius + fuzziness;
+    }
+}
+
+static void Fq(double q, double *F1, double *F2, double sld, double sld_solvent,
+               double radius, double fuzziness)
+{
+    const double qr = q*radius;
+    const double bes = sas_3j1x_x(qr);
+    const double qf = exp(-0.5*square(q*fuzziness));
+    const double contrast = (sld - sld_solvent);
+    const double form = contrast * form_volume(radius,fuzziness) * bes * qf;
+    *F1 = 1.0e-2*form;
+    *F2 = 1.0e-4*form*form;
+}
Index: sasmodels/models/fuzzy_sphere.py
===================================================================
--- sasmodels/models/fuzzy_sphere.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/fuzzy_sphere.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -78,37 +78,11 @@
               ["sld_solvent", "1e-6/Ang^2",  3, [-inf, inf], "sld",    "Solvent scattering length density"],
               ["radius",      "Ang",        60, [0, inf],    "volume", "Sphere radius"],
-              ["fuzziness",   "Ang",        10, [0, inf],    "",       "std deviation of Gaussian convolution for interface (must be << radius)"],
+              ["fuzziness",   "Ang",        10, [0, inf],    "volume",       "std deviation of Gaussian convolution for interface (must be << radius)"],
              ]
 # pylint: enable=bad-whitespace,line-too-long
 
-source = ["lib/sas_3j1x_x.c"]
+source = ["lib/sas_3j1x_x.c","fuzzy_sphere.c"]
 have_Fq = True
-
-c_code = """
-static double form_volume(double radius)
-{
-    return M_4PI_3*cube(radius);
-}
-
-static void Fq(double q, double *F1, double *F2, double sld, double sld_solvent,
-               double radius, double fuzziness)
-{
-    const double qr = q*radius;
-    const double bes = sas_3j1x_x(qr);
-    const double qf = exp(-0.5*square(q*fuzziness));
-    const double contrast = (sld - sld_solvent);
-    const double form = contrast * form_volume(radius) * bes * qf;
-    *F1 = 1.0e-2*form;
-    *F2 = 1.0e-4*form*form;
-}
-"""
-
-def ER(radius):
-    """
-    Return radius
-    """
-    return radius
-
-# VR defaults to 1.0
+effective_radius_type = ["radius", "radius + fuzziness"]
 
 def random():
Index: sasmodels/models/hollow_cylinder.c
===================================================================
--- sasmodels/models/hollow_cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_cylinder.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -15,11 +15,50 @@
 }
 
+// TODO: interface to form_volume/shell_volume not yet settled
+static double
+shell_volume(double *total, double radius, double thickness, double length)
+{
+    *total = M_PI*length*square(radius+thickness);
+    return *total - M_PI*length*radius*radius;
+}
+
 static double
 form_volume(double radius, double thickness, double length)
 {
-    double v_shell = M_PI*length*(square(radius+thickness) - radius*radius);
-    return v_shell;
+    double total;
+    return shell_volume(&total, radius, thickness, length);
 }
 
+static double
+radius_from_volume(double radius, double thickness, double length)
+{
+    const double volume_outer_cyl = M_PI*square(radius + thickness)*length;
+    return cbrt(0.75*volume_outer_cyl/M_PI);
+}
+
+static double
+radius_from_diagonal(double radius, double thickness, double length)
+{
+    return sqrt(square(radius + thickness) + 0.25*square(length));
+}
+
+static double
+effective_radius(int mode, double radius, double thickness, double length)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(radius, thickness, length);
+    case 2: // outer radius
+        return radius + thickness;
+    case 3: // half length
+        return 0.5*length;
+    case 4: // half outer min dimension
+        return (radius + thickness < 0.5*length ? radius + thickness : 0.5*length);
+    case 5: // half outer max dimension
+        return (radius + thickness > 0.5*length ? radius + thickness : 0.5*length);
+    case 6: // half outer diagonal
+        return radius_from_diagonal(radius,thickness,length);
+    }
+}
 
 static void
Index: sasmodels/models/hollow_cylinder.py
===================================================================
--- sasmodels/models/hollow_cylinder.py	(revision 455aaa1fbc231bb1caf309ca6419f0e3ffd5e19c)
+++ sasmodels/models/hollow_cylinder.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -100,36 +100,9 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "hollow_cylinder.c"]
 have_Fq = True
-
-# pylint: disable=W0613
-def ER(radius, thickness, length):
-    """
-    :param radius:      Cylinder core radius
-    :param thickness:   Cylinder wall thickness
-    :param length:      Cylinder length
-    :return:            Effective radius
-    """
-    router = radius + thickness
-    if router == 0 or length == 0:
-        return 0.0
-    len1 = router
-    len2 = length/2.0
-    term1 = len1*len1*2.0*len2/2.0
-    term2 = 1.0 + (len2/len1)*(1.0 + 1/len2/2.0)*(1.0 + pi*len1/len2/2.0)
-    ddd = 3.0*term1*term2
-    diam = pow(ddd, (1.0/3.0))
-    return diam
-
-def VR(radius, thickness, length):
-    """
-    :param radius:      Cylinder radius
-    :param thickness:   Cylinder wall thickness
-    :param length:      Cylinder length
-    :return:            Volf ratio for P(q)*S(q)
-    """
-    router = radius + thickness
-    vol_core = pi*radius*radius*length
-    vol_total = pi*router*router*length
-    vol_shell = vol_total - vol_core
-    return vol_total, vol_shell
+effective_radius_type = [
+    "equivalent sphere", "outer radius", "half length",
+    "half outer min dimension", "half outer max dimension",
+    "half outer diagonal",
+    ]
 
 def random():
@@ -162,5 +135,5 @@
 tests = [
     [{}, 0.00005, 1764.926],
-    [{}, 'VR', 0.55555556],
+#    [{}, 'VR', 0.55555556],
     [{}, 0.001, 1756.76],
     [{}, (qx, qy), 2.36885476192],
Index: sasmodels/models/hollow_rectangular_prism.c
===================================================================
--- sasmodels/models/hollow_rectangular_prism.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_rectangular_prism.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -1,4 +1,5 @@
+// TODO: interface to form_volume/shell_volume not yet settled
 static double
-form_volume(double length_a, double b2a_ratio, double c2a_ratio, double thickness)
+shell_volume(double *total, double length_a, double b2a_ratio, double c2a_ratio, double thickness)
 {
     double length_b = length_a * b2a_ratio;
@@ -8,7 +9,37 @@
     double c_core = length_c - 2.0*thickness;
     double vol_core = a_core * b_core * c_core;
-    double vol_total = length_a * length_b * length_c;
-    double vol_shell = vol_total - vol_core;
-    return vol_shell;
+    *total = length_a * length_b * length_c;
+    return *total - vol_core;
+}
+
+static double
+form_volume(double length_a, double b2a_ratio, double c2a_ratio, double thickness)
+{
+    double total;
+    return shell_volume(&total, length_a, b2a_ratio, c2a_ratio, thickness);
+}
+
+static double
+effective_radius(int mode, double length_a, double b2a_ratio, double c2a_ratio, double thickness)
+//effective_radius_type = ["equivalent sphere","half length_a", "half length_b", "half length_c",
+//                         "equivalent outer circular cross-section","half ab diagonal","half diagonal"]
+// NOTE length_a is external dimension!
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return cbrt(0.75*cube(length_a)*b2a_ratio*c2a_ratio/M_PI);
+    case 2: // half length_a
+        return 0.5 * length_a;
+    case 3: // half length_b
+        return 0.5 * length_a*b2a_ratio;
+    case 4: // half length_c
+        return 0.5 * length_a*c2a_ratio;
+    case 5: // equivalent outer circular cross-section
+        return length_a*sqrt(b2a_ratio/M_PI);
+    case 6: // half ab diagonal
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio)));
+    case 7: // half diagonal
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio) + square(c2a_ratio)));
+    }
 }
 
Index: sasmodels/models/hollow_rectangular_prism.py
===================================================================
--- sasmodels/models/hollow_rectangular_prism.py	(revision 455aaa1fbc231bb1caf309ca6419f0e3ffd5e19c)
+++ sasmodels/models/hollow_rectangular_prism.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -132,5 +132,5 @@
                "Solvent scattering length density"],
               ["length_a", "Ang", 35, [0, inf], "volume",
-               "Shorter side of the parallelepiped"],
+               "Shortest, external, size of the parallelepiped"],
               ["b2a_ratio", "Ang", 1, [0, inf], "volume",
                "Ratio sides b/a"],
@@ -149,33 +149,9 @@
 source = ["lib/gauss76.c", "hollow_rectangular_prism.c"]
 have_Fq = True
-
-def ER(length_a, b2a_ratio, c2a_ratio, thickness):
-    """
-    Return equivalent radius (ER)
-    thickness parameter not used
-    """
-    b_side = length_a * b2a_ratio
-    c_side = length_a * c2a_ratio
-
-    # surface average radius (rough approximation)
-    surf_rad = sqrt(length_a * b_side / pi)
-
-    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
-    return 0.5 * (ddd) ** (1. / 3.)
-
-def VR(length_a, b2a_ratio, c2a_ratio, thickness):
-    """
-    Return shell volume and total volume
-    """
-    b_side = length_a * b2a_ratio
-    c_side = length_a * c2a_ratio
-    a_core = length_a - 2.0*thickness
-    b_core = b_side - 2.0*thickness
-    c_core = c_side - 2.0*thickness
-    vol_core = a_core * b_core * c_core
-    vol_total = length_a * b_side * c_side
-    vol_shell = vol_total - vol_core
-    return vol_total, vol_shell
-
+effective_radius_type = [
+    "equivalent sphere", "half length_a", "half length_b", "half length_c",
+    "equivalent outer circular cross-section",
+    "half ab diagonal", "half diagonal",
+    ]
 
 def random():
Index: sasmodels/models/hollow_rectangular_prism_thin_walls.c
===================================================================
--- sasmodels/models/hollow_rectangular_prism_thin_walls.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_rectangular_prism_thin_walls.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -1,9 +1,40 @@
+// TODO: interface to form_volume/shell_volume not yet settled
 static double
-form_volume(double length_a, double b2a_ratio, double c2a_ratio)
+shell_volume(double *total, double length_a, double b2a_ratio, double c2a_ratio)
 {
     double length_b = length_a * b2a_ratio;
     double length_c = length_a * c2a_ratio;
     double vol_shell = 2.0 * (length_a*length_b + length_a*length_c + length_b*length_c);
+    *total = length_a * length_b * length_c;
     return vol_shell;
+}
+
+static double
+form_volume(double length_a, double b2a_ratio, double c2a_ratio)
+{
+    double total;
+    return shell_volume(&total, length_a, b2a_ratio, c2a_ratio);
+}
+
+
+static double
+effective_radius(int mode, double length_a, double b2a_ratio, double c2a_ratio)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return cbrt(0.75*cube(length_a)*b2a_ratio*c2a_ratio/M_PI);
+    case 2: // half length_a
+        return 0.5 * length_a;
+    case 3: // half length_b
+        return 0.5 * length_a*b2a_ratio;
+    case 4: // half length_c
+        return 0.5 * length_a*c2a_ratio;
+    case 5: // equivalent outer circular cross-section
+        return length_a*sqrt(b2a_ratio/M_PI);
+    case 6: // half ab diagonal
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio)));
+    case 7: // half diagonal
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio) + square(c2a_ratio)));
+    }
 }
 
Index: sasmodels/models/hollow_rectangular_prism_thin_walls.py
===================================================================
--- sasmodels/models/hollow_rectangular_prism_thin_walls.py	(revision 6e7d7b66fc1ec444c4e30ac47db7bbcdc554ecc3)
+++ sasmodels/models/hollow_rectangular_prism_thin_walls.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -109,27 +109,9 @@
 source = ["lib/gauss76.c", "hollow_rectangular_prism_thin_walls.c"]
 have_Fq = True
-
-def ER(length_a, b2a_ratio, c2a_ratio):
-    """
-        Return equivalent radius (ER)
-    """
-    b_side = length_a * b2a_ratio
-    c_side = length_a * c2a_ratio
-
-    # surface average radius (rough approximation)
-    surf_rad = sqrt(length_a * b_side / pi)
-
-    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
-    return 0.5 * (ddd) ** (1. / 3.)
-
-def VR(length_a, b2a_ratio, c2a_ratio):
-    """
-        Return shell volume and total volume
-    """
-    b_side = length_a * b2a_ratio
-    c_side = length_a * c2a_ratio
-    vol_total = length_a * b_side * c_side
-    vol_shell = 2.0 * (length_a*b_side + length_a*c_side + b_side*c_side)
-    return vol_shell, vol_total
+effective_radius_type = [
+    "equivalent sphere", "half length_a", "half length_b", "half length_c",
+    "equivalent outer circular cross-section",
+    "half ab diagonal", "half diagonal",
+    ]
 
 
Index: sasmodels/models/mono_gauss_coil.c
===================================================================
--- sasmodels/models/mono_gauss_coil.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
+++ sasmodels/models/mono_gauss_coil.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -0,0 +1,60 @@
+static double form_volume(double rg)
+{
+    return 1.0;
+}
+
+static double
+effective_radius(int mode, double rg)
+{
+    switch (mode) {
+    case 1: // R_g
+        return rg;
+    case 2: // 2R_g
+        return 2.0*rg;
+    case 3: // 3R_g
+        return 3.0*rg;
+    case 4: // (5/3)^0.5*R_g
+        return sqrt(5.0/3.0)*rg;
+    }
+}
+
+static double
+gauss_coil(double qr)
+{
+    const double x = qr*qr;
+
+    // Use series expansion at low q for higher accuracy. We could use
+    // smaller polynomials if we sacrifice some digits of precision or
+    // introduce an additional series expansion around x == 1.
+    // See explore/precision.py, gauss_coil function.
+#if FLOAT_SIZE>4 // DOUBLE_PRECISION
+    // For double precision: use O(5) Pade with 0.5 cutoff (10 mad + 1 divide)
+    if (x < 0.5) {
+        // PadeApproximant[2*Exp[-x^2] + x^2-1)/x^4, {x, 0, 8}]
+        const double A1=1./12., A2=2./99., A3=1./2640., A4=1./23760., A5=-1./1995840.;
+        const double B1=5./12., B2=5./66., B3=1./132., B4=1./2376., B5=1./95040.;
+        return (((((A5*x + A4)*x + A3)*x + A2)*x + A1)*x + 1.)
+                / (((((B5*x + B4)*x + B3)*x + B2)*x + B1)*x + 1.);
+    }
+#else
+    // For single precision: use O(7) Taylor with 0.8 cutoff (7 mad)
+    if (x < 0.8) {
+        const double C0 = +1.;
+        const double C1 = -1./3.;
+        const double C2 = +1./12.;
+        const double C3 = -1./60.;
+        const double C4 = +1./360.;
+        const double C5 = -1./2520.;
+        const double C6 = +1./20160.;
+        const double C7 = -1./181440.;
+        return ((((((C7*x + C6)*x + C5)*x + C4)*x + C3)*x + C2)*x + C1)*x + C0;
+    }
+#endif
+
+    return 2.0 * (expm1(-x) + x)/(x*x);
+}
+
+double Iq(double q, double i_zero, double rg)
+{
+    return i_zero * gauss_coil(q*rg);
+}
Index: sasmodels/models/mono_gauss_coil.py
===================================================================
--- sasmodels/models/mono_gauss_coil.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/mono_gauss_coil.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -54,5 +54,5 @@
 
 import numpy as np
-from numpy import inf, exp, errstate
+from numpy import inf
 
 name = "mono_gauss_coil"
@@ -69,18 +69,12 @@
 parameters = [
     ["i_zero", "1/cm", 70.0, [0.0, inf], "", "Intensity at q=0"],
-    ["rg", "Ang", 75.0, [0.0, inf], "", "Radius of gyration"],
+    ["rg", "Ang", 75.0, [0.0, inf], "volume", "Radius of gyration"],
     ]
 # pylint: enable=bad-whitespace, line-too-long
 
-# NB: Scale and Background are implicit parameters on every model
-def Iq(q, i_zero, rg):
-    # pylint: disable = missing-docstring
-    z = (q * rg)**2
+source = ["mono_gauss_coil.c"]
+have_Fq = False
+effective_radius_type = ["R_g", "2R_g", "3R_g", "(5/3)^0.5*R_g"]
 
-    with errstate(invalid='ignore'):
-        inten = (i_zero * 2.0) * (exp(-z) + z - 1.0)/z**2
-        inten[q == 0] = i_zero
-    return inten
-Iq.vectorized = True # Iq accepts an array of q values
 
 def random():
Index: sasmodels/models/multilayer_vesicle.c
===================================================================
--- sasmodels/models/multilayer_vesicle.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/multilayer_vesicle.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -47,4 +47,11 @@
 }
 
+static double
+effective_radius(int mode, double radius, double thick_shell, double thick_solvent, double fp_n_shells)
+{
+    // case 1: outer radius
+    return radius + fp_n_shells*thick_shell + (fp_n_shells - 1.0)*thick_solvent;
+}
+
 static void
 Fq(double q,
Index: sasmodels/models/multilayer_vesicle.py
===================================================================
--- sasmodels/models/multilayer_vesicle.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/multilayer_vesicle.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -146,8 +146,5 @@
 source = ["lib/sas_3j1x_x.c", "multilayer_vesicle.c"]
 have_Fq = True
-
-def ER(radius, thick_shell, thick_solvent, n_shells):
-    n_shells = int(n_shells+0.5)
-    return radius + n_shells * (thick_shell + thick_solvent) - thick_solvent
+effective_radius_type = ["outer radius"]
 
 def random():
Index: sasmodels/models/onion.c
===================================================================
--- sasmodels/models/onion.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/onion.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -30,5 +30,5 @@
 
 static double
-form_volume(double radius_core, double n_shells, double thickness[])
+outer_radius(double radius_core, double n_shells, double thickness[])
 {
   int n = (int)(n_shells+0.5);
@@ -37,5 +37,18 @@
     r += thickness[i];
   }
-  return M_4PI_3*cube(r);
+  return r;
+}
+
+static double
+form_volume(double radius_core, double n_shells, double thickness[])
+{
+  return M_4PI_3*cube(outer_radius(radius_core, n_shells, thickness));
+}
+
+static double
+effective_radius(int mode, double radius_core, double n_shells, double thickness[])
+{
+  // case 1: outer radius
+  return outer_radius(radius_core, n_shells, thickness);
 }
 
Index: sasmodels/models/onion.py
===================================================================
--- sasmodels/models/onion.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/onion.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -316,4 +316,5 @@
 single = False
 have_Fq = True
+effective_radius_type = ["outer radius"]
 
 profile_axes = ['Radius (A)', 'SLD (1e-6/A^2)']
@@ -365,9 +366,4 @@
 
     return np.asarray(z), np.asarray(rho)
-
-def ER(radius_core, n_shells, thickness):
-    """Effective radius"""
-    n = int(n_shells[0]+0.5)
-    return np.sum(thickness[:n], axis=0) + radius_core
 
 demo = {
Index: sasmodels/models/parallelepiped.c
===================================================================
--- sasmodels/models/parallelepiped.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/parallelepiped.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -5,4 +5,24 @@
 }
 
+static double
+effective_radius(int mode, double length_a, double length_b, double length_c)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return cbrt(0.75*length_a*length_b*length_c/M_PI);
+    case 2: // half length_a
+        return 0.5 * length_a;
+    case 3: // half length_b
+        return 0.5 * length_b;
+    case 4: // half length_c
+        return 0.5 * length_c;
+    case 5: // equivalent circular cross-section
+        return sqrt(length_a*length_b/M_PI);
+    case 6: // half ab diagonal
+        return 0.5*sqrt(length_a*length_a + length_b*length_b);
+    case 7: // half diagonal
+        return 0.5*sqrt(length_a*length_a + length_b*length_b + length_c*length_c);
+    }
+}
 
 static void
Index: sasmodels/models/parallelepiped.py
===================================================================
--- sasmodels/models/parallelepiped.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/parallelepiped.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -140,5 +140,5 @@
    ensuring that the inequality $A < B < C$ is not violated,  The calculation
    will not report an error, but the results may be not correct.
-   
+
 .. _parallelepiped-orientation:
 
@@ -231,23 +231,8 @@
 source = ["lib/gauss76.c", "parallelepiped.c"]
 have_Fq = True
-
-def ER(length_a, length_b, length_c):
-    """
-    Return effective radius (ER) for P(q)*S(q)
-    """
-    # now that axes can be in any size order, need to sort a,b,c
-    # where a~b and c is either much smaller or much larger
-    abc = np.vstack((length_a, length_b, length_c))
-    abc = np.sort(abc, axis=0)
-    selector = (abc[1] - abc[0]) > (abc[2] - abc[1])
-    length = np.where(selector, abc[0], abc[2])
-    # surface average radius (rough approximation)
-    radius = sqrt(np.where(~selector, abc[0]*abc[1], abc[1]*abc[2]) / pi)
-
-    ddd = 0.75 * radius * (2*radius*length + (length + radius)*(length + pi*radius))
-    return 0.5 * (ddd) ** (1. / 3.)
-
-# VR defaults to 1.0
-
+effective_radius_type = [
+    "equivalent sphere", "half length_a", "half length_b", "half length_c",
+    "equivalent circular cross-section", "half ab diagonal", "half diagonal",
+    ]
 
 def random():
Index: sasmodels/models/pearl_necklace.py
===================================================================
--- sasmodels/models/pearl_necklace.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/pearl_necklace.py	(revision 2cc8aa2a798267dbefb6309f9f93a254fa180b82)
@@ -140,4 +140,7 @@
             thick_string_pd=0.2, thick_string_pd_n=5,
            )
-
-tests = [[{}, 0.001, 17380.245], [{}, 'ER', 115.39502]]
+# ER function is not being used here, not that it is likely very sensible to 
+# include an S(Q) with this model, the default in sasview 5.0 would be to the 
+# "unconstrained" radius_effective.
+#tests = [[{}, 0.001, 17380.245], [{}, 'ER', 115.39502]]
+tests = [[{}, 0.001, 17380.245]]
Index: sasmodels/models/pringle.c
===================================================================
--- sasmodels/models/pringle.c	(revision 74768cb764a04223ec9e992e316cb8c211adfe34)
+++ sasmodels/models/pringle.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -104,4 +104,15 @@
 }
 
+static double
+effective_radius(int mode, double radius, double thickness, double alpha, double beta)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return cbrt(0.75*radius*radius*thickness);
+    case 2: // radius
+        return radius;
+    }
+}
+
 double Iq(
     double q,
Index: sasmodels/models/pringle.py
===================================================================
--- sasmodels/models/pringle.py	(revision ef07e950965796e2a3a8156fcade98ce5e403001)
+++ sasmodels/models/pringle.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -72,14 +72,7 @@
 
 
-source = ["lib/polevl.c", "lib/sas_J0.c", "lib/sas_J1.c", \
+source = ["lib/polevl.c", "lib/sas_J0.c", "lib/sas_J1.c",
           "lib/sas_JN.c", "lib/gauss76.c", "pringle.c"]
-
-def ER(radius, thickness, alpha, beta):
-    """
-    Return equivalent radius (ER)
-    """
-    ddd = 0.75 * radius * (2 * radius * thickness + (thickness + radius) \
-                           * (thickness + pi * radius))
-    return 0.5 * (ddd) ** (1. / 3.)
+effective_radius_type = ["equivalent sphere", "radius"]
 
 def random():
Index: sasmodels/models/raspberry.c
===================================================================
--- sasmodels/models/raspberry.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/raspberry.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -1,3 +1,3 @@
-double form_volume(double radius_lg);
+double form_volume(double radius_lg, double radius_sm, double penetration);
 
 double Iq(double q,
@@ -6,5 +6,5 @@
           double radius_lg, double radius_sm, double penetration);
 
-double form_volume(double radius_lg)
+double form_volume(double radius_lg, double radius_sm, double penetration)
 {
     //Because of the complex structure, volume normalization must
@@ -12,4 +12,15 @@
     double volume=1.0;
     return volume;
+}
+
+static double
+effective_radius(int mode, double radius_lg, double radius_sm, double penetration)
+{
+    switch (mode) {
+    case 1: // radius_large
+        return radius_lg;
+    case 2: // radius_outer
+        return radius_lg + 2.0*radius_sm - penetration;
+    }
 }
 
Index: sasmodels/models/raspberry.py
===================================================================
--- sasmodels/models/raspberry.py	(revision ef07e950965796e2a3a8156fcade98ce5e403001)
+++ sasmodels/models/raspberry.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -145,11 +145,12 @@
               ["radius_lg", "Ang", 5000, [0, inf], "volume",
                "radius of large spheres"],
-              ["radius_sm", "Ang", 100, [0, inf], "",
+              ["radius_sm", "Ang", 100, [0, inf], "volume",
                "radius of small spheres"],
-              ["penetration", "Ang", 0, [-1, 1], "",
+              ["penetration", "Ang", 0, [-1, 1], "volume",
                "fractional penetration depth of small spheres into large sphere"],
              ]
 
 source = ["lib/sas_3j1x_x.c", "raspberry.c"]
+effective_radius_type = ["radius_large", "radius_outer"]
 
 def random():
Index: sasmodels/models/rectangular_prism.c
===================================================================
--- sasmodels/models/rectangular_prism.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/rectangular_prism.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -3,4 +3,25 @@
 {
     return length_a * (length_a*b2a_ratio) * (length_a*c2a_ratio);
+}
+
+static double
+effective_radius(int mode, double length_a, double b2a_ratio, double c2a_ratio)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return cbrt(0.75*cube(length_a)*b2a_ratio*c2a_ratio/M_PI);
+    case 2: // half length_a
+        return 0.5 * length_a;
+    case 3: // half length_b
+        return 0.5 * length_a*b2a_ratio;
+    case 4: // half length_c
+        return 0.5 * length_a*c2a_ratio;
+    case 5: // equivalent circular cross-section
+        return length_a*sqrt(b2a_ratio/M_PI);
+    case 6: // half ab diagonal
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio)));
+    case 7: // half diagonal
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio) + square(c2a_ratio)));
+    }
 }
 
Index: sasmodels/models/rectangular_prism.py
===================================================================
--- sasmodels/models/rectangular_prism.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/rectangular_prism.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -136,17 +136,8 @@
 source = ["lib/gauss76.c", "rectangular_prism.c"]
 have_Fq = True
-
-def ER(length_a, b2a_ratio, c2a_ratio):
-    """
-        Return equivalent radius (ER)
-    """
-    b_side = length_a * b2a_ratio
-    c_side = length_a * c2a_ratio
-
-    # surface average radius (rough approximation)
-    surf_rad = sqrt(length_a * b_side / pi)
-
-    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
-    return 0.5 * (ddd) ** (1. / 3.)
+effective_radius_type = [
+    "equivalent sphere", "half length_a", "half length_b", "half length_c",
+    "equivalent circular cross-section", "half ab diagonal", "half diagonal",
+    ]
 
 def random():
Index: sasmodels/models/sphere.c
===================================================================
--- sasmodels/models/sphere.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
+++ sasmodels/models/sphere.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -0,0 +1,20 @@
+static double form_volume(double radius)
+{
+    return M_4PI_3*cube(radius);
+}
+
+static double
+effective_radius(int mode, double radius)
+{
+    // case 1: radius
+    return radius;
+}
+
+static void Fq(double q, double *f1, double *f2, double sld, double sld_solvent, double radius)
+{
+    const double bes = sas_3j1x_x(q*radius);
+    const double contrast = (sld - sld_solvent);
+    const double form = contrast * form_volume(radius) * bes;
+    *f1 = 1.0e-2*form;
+    *f2 = 1.0e-4*form*form;
+}
Index: sasmodels/models/sphere.py
===================================================================
--- sasmodels/models/sphere.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/sphere.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -67,30 +67,7 @@
              ]
 
-source = ["lib/sas_3j1x_x.c"]
+source = ["lib/sas_3j1x_x.c","sphere.c"]
 have_Fq = True
-
-c_code = """
-static double form_volume(double radius)
-{
-    return M_4PI_3*cube(radius);
-}
-
-static void Fq(double q, double *f1, double *f2, double sld, double sld_solvent, double radius)
-{
-    const double bes = sas_3j1x_x(q*radius);
-    const double contrast = (sld - sld_solvent);
-    const double form = contrast * form_volume(radius) * bes;
-    *f1 = 1.0e-2*form;
-    *f2 = 1.0e-4*form*form;
-}
-"""
-
-def ER(radius):
-    """
-    Return equivalent radius (ER)
-    """
-    return radius
-
-# VR defaults to 1.0
+effective_radius_type = ["radius"]
 
 def random():
@@ -106,5 +83,5 @@
       "radius": 120., "radius_pd": 0.2, "radius_pd_n":45},
      0.2, 0.228843],
-    [{"radius": 120., "radius_pd": 0.2, "radius_pd_n":45}, "ER", 120.],
-    [{"radius": 120., "radius_pd": 0.2, "radius_pd_n":45}, "VR", 1.],
+#    [{"radius": 120., "radius_pd": 0.2, "radius_pd_n":45}, "ER", 120.],
+#    [{"radius": 120., "radius_pd": 0.2, "radius_pd_n":45}, "VR", 1.],
 ]
Index: sasmodels/models/spherical_sld.c
===================================================================
--- sasmodels/models/spherical_sld.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/spherical_sld.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -1,6 +1,4 @@
-static double form_volume(
-    double fp_n_shells,
-    double thickness[],
-    double interface[])
+static double
+outer_radius(double fp_n_shells, double thickness[], double interface[])
 {
     int n_shells= (int)(fp_n_shells + 0.5);
@@ -9,5 +7,20 @@
         r += thickness[i] + interface[i];
     }
-    return M_4PI_3*cube(r);
+    return r;
+}
+
+static double form_volume(
+    double fp_n_shells,
+    double thickness[],
+    double interface[])
+{
+    return M_4PI_3*cube(outer_radius(fp_n_shells, thickness, interface));
+}
+
+static double
+effective_radius(int mode, double fp_n_shells, double thickness[], double interface[])
+{
+    // case 1: outer radius
+    return outer_radius(fp_n_shells, thickness, interface);
 }
 
